-- MH-Z19B calibrate
local RAW = {}
local clb = ''
local exit = function(kl)
	uart.on("data")
	uart.alt(0)
	uart.setup(0, 115200, 8, uart.PARITY_NONE, uart.STOPBITS_1, 0)
	table.foreach(RAW, print)
	if killt then killt:stop(); killt:unregister(); killt = nil end
	tmrwork:start()
	if not kl then print('UART Killed!') end
	print('Calibrated at '..clb)
	if #RAW > 0 then
		local ans = ''
		for _, v in ipairs(RAW) do
			ans = ans..string.format("0x%02x", v)..', '
		end
		print(ans)
		if m and dat and dat.broker == true then
			m:publish(dat.clnt..'/answer', ans, 2, 0) 
		end
	end
end

local killt = tmr.create()
killt:alarm(10000, tmr.ALARM_SINGLE, exit)

local calibr = function(com)
	local ustart = false
	uart.alt(1)
	if call then local call = call end
	uart.setup(0, 9600, 8, uart.PARITY_NONE, uart.STOPBITS_1, 0)
	uart.on("data",1,
	    function(data)
	    	if ustart == false and string.byte(data, 1) ~= 255	then 
	    		return
	    	elseif ustart == false then 
	    		ustart = true
	    	end
	    	RAW[#RAW+1] = string.byte(data, 1)
	    	if #RAW == 9 then exit(true) end
	    end, 0)
	if clb == 'ZERO' then
		uart.write(0,255,1,135,0,0,0,0,0,120) -- Zero clb
	elseif clb == 'ABCOFF' then
		uart.write(0,255,1,121,0,0,0,0,0,134) -- ABC off
	elseif clb == 'ABCON' then
		uart.write(0,255,1,121,160,0,0,0,0,230) -- ABC on
	end
end

return function(com)
	tmrwork:stop()
	clb = com
	tmr.create():alarm(4000, tmr.ALARM_SINGLE,calibr)
end
